import { instrument } from "@microlabs/otel-cf-workers";
import { EXPORT_URL, HIGHLIGHT_PROJECT_ID } from "./consts";
import { parseHighlightFromHeaders } from "./parse-highlight-header";
export function instrumentCfWorker(handler, config) {
    const otelConfig = (_env, trigger)=>{
        return {
            exporter: {
                url: EXPORT_URL
            },
            postProcessor: (spans)=>{
                return spans.map((span)=>{
                    span.attributes["highlight.project_id"] = HIGHLIGHT_PROJECT_ID;
                    span.attributes["highlight.source"] = "backend";
                    if (trigger instanceof Request) {
                        const attrs = parseHighlightFromHeaders(trigger.headers, {
                            get: (headers, key)=>headers.get(key)
                        });
                        if (attrs) {
                            span.attributes["highlight.session_id"] = attrs["highlight.session_id"];
                            span.attributes["highlight.trace_id"] = attrs["highlight.trace_id"];
                        }
                    }
                    return span;
                });
            },
            service: {
                name: config.serviceName
            }
        };
    };
    return instrument(handler, otelConfig);
}
